'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 27 February 2004 at 5:23:26 pm'!
"Change Set:		NewPLMRefactoring
Date:			27 February 2004
Author:			Masashi Umezawa

It is a refactoring of the new PLM introduced in 3.7a-3707.

What I have done are:

-remove unsent messages.
-rename messages for clearness.
-remove not-referred variables.
-add text listing feature (with color and emphasis).
-add morph listing feature.
-add hooks for PLM model to decorate list items on demand.
 
No SUnit tests, but I attached a simple test class for showing how it works.

"!

Morph subclass: #LazyListMorph
	instanceVariableNames: 'listItems font selectedRow selectedRows listSource selectedRowIndex selectionColor textItemMorphClass selectionBackgroundColor '
	classVariableNames: 'SelectionBackgroundColor SelectionColor RowColor '
	poolDictionaries: ''
	category: 'Morphic-Windows'!
Object subclass: #PLMSimpleTestModel
	instanceVariableNames: 'selectedListIndex list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Morphic-Windows'!

!Browser methodsFor: 'initialize-release' stamp: 'mu 2/25/2004 18:09'!
buildMorphicClassList

	| myClassList |

	(myClassList _ PluggableListMorph new) 
			on: self list: #classList
			selected: #classListIndex changeSelected: #classListIndex:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:.
	myClassList borderWidth: 0.
	myClassList enableDragNDrop: Preferences browseWithDragNDrop.
	myClassList doubleClickSelector: #browseSelectionInPlace.
	^myClassList

! !

!Browser methodsFor: 'initialize-release' stamp: 'mu 2/25/2004 18:09'!
buildMorphicMessageCatList

	| myMessageCatList |

	(myMessageCatList _ PluggableMessageCategoryListMorph new) 
			on: self list: #messageCategoryList
			selected: #messageCategoryListIndex changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu: 
			keystroke: #arrowKey:from: getRawListSelector: #rawMessageCategoryList.
	myMessageCatList enableDragNDrop: Preferences browseWithDragNDrop.
	^myMessageCatList
! !

!Browser methodsFor: 'initialize-release' stamp: 'mu 2/25/2004 19:06'!
buildMorphicMessageList
	"Build a morphic message list, with #messageList as its list-getter"

	| aListMorph |
	(aListMorph _ PluggableListMorph new) 
			setProperty: #balloonTextSelectorForSubMorphs toValue: #balloonTextForMethodString;
			on: self list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	aListMorph enableDragNDrop: Preferences browseWithDragNDrop.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	^aListMorph

! !

!Browser methodsFor: 'initialize-release' stamp: 'mu 2/25/2004 18:09'!
buildMorphicSystemCatList
	| dragNDropFlag myCatList |
	dragNDropFlag _ Preferences browseWithDragNDrop.
	(myCatList _ PluggableListMorph new) 
			on: self list: #systemCategoryList
			selected: #systemCategoryListIndex changeSelected: #systemCategoryListIndex:
			menu: #systemCategoryMenu: keystroke: #systemCatListKey:from:.
	myCatList enableDragNDrop: dragNDropFlag.
	^myCatList
! !


!LazyListMorph methodsFor: 'initialization' stamp: 'mu 2/25/2004 17:47'!
initialize
	super initialize.
	self color: self class rowColor.
	font := Preferences standardListFont.
	self listItems: #().
	selectedRowIndex := nil.
	self adjustHeight.! !

!LazyListMorph methodsFor: 'list management' stamp: 'mu 2/25/2004 00:04'!
drawingBoundsForRow: row
	"calculate the bounds that row should be drawn at.  This might be outside our bounds!!"
	| upperHeight topLeft drawBounds visibleWidth |
	upperHeight := self upperListHeightTo: row.
	topLeft := self topLeft x @ (self topLeft y + upperHeight).
	visibleWidth := self width - listSource scrollBar width.
	drawBounds := topLeft extent: visibleWidth @ (self heightOf: (self itemAt: row)).
	^drawBounds! !

!LazyListMorph methodsFor: 'list management' stamp: 'mu 2/22/2004 19:31'!
listChanged
	"set newList to be the list of strings to display"
	self listItems: (Array new: self getListSize).
	selectedRowIndex := nil.
	self adjustHeight.
	self changed.! !

!LazyListMorph methodsFor: 'list management' stamp: 'mu 2/25/2004 00:49'!
rowAtLocation: aPoint 
	"return the index of the row at aPoint"
	| y height maxIndex |
	y := aPoint y.
	y < self top ifTrue: [^ 1].
	height := 0.
	maxIndex := self getListSize.
	1 to: maxIndex
		do: [:idx | 
			| item eachHeight | 
			item := self itemAt: idx.
			eachHeight := self heightOf: item.
			height := height + eachHeight.
			y < (self top + height)
						ifTrue: [^ idx]].
	^ maxIndex! !

!LazyListMorph methodsFor: 'list management' stamp: 'mu 2/25/2004 18:29'!
rowIsSelected: rowIndex
	^listSource rowIsSelected: rowIndex! !

!LazyListMorph methodsFor: 'list management' stamp: 'mu 2/20/2004 19:21'!
selectedRowIndex
	"return the currently selected row, or nil if none is selected"
	^selectedRowIndex! !

!LazyListMorph methodsFor: 'list management' stamp: 'mu 2/20/2004 19:16'!
selectedRowIndex: index
	selectedRowIndex := index.
	self changed.! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mu 2/24/2004 22:58'!
display: item atRow: row on: canvas 
	"display the given item at row row"
	item isMorph
		ifTrue: [self
				displayMorph: item
				atRow: row
				on: canvas]
		ifFalse: [self
				displayText: item asStringOrText
				atRow: row
				on: canvas]! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mu 2/25/2004 17:55'!
displayMorph: itemMorph atRow: rowIndex on: canvas
	| drawBounds |
	drawBounds := self drawingBoundsForRow: rowIndex.
	itemMorph bounds: drawBounds.
	listSource highlightMorphItemSelector ifNotNil: [
		itemMorph
				setProperty: #colorInRow
				toValue: (self foregroundColorForRow: rowIndex).
		itemMorph
				setProperty: #selectedInRow
				toValue: (self rowIsSelected: rowIndex).
		listSource model perform: listSource highlightMorphItemSelector with: itemMorph].
	itemMorph drawOn: canvas! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mu 2/25/2004 18:03'!
displayText: item atRow: rowIndex on: canvas 
	"display the given item at row row"
	| drawBounds textColor |
	drawBounds := self drawingBoundsForRow: rowIndex.
	drawBounds := drawBounds intersect: self bounds.
	textColor := self foregroundColorForRow: rowIndex.
	listSource highlightTextItemSelector
		ifNotNil: [| itemMorph | 
			itemMorph := self textItemMorphClass contents: item font: font.
			itemMorph bounds: drawBounds.
			itemMorph color: textColor.
			listSource model perform: listSource highlightTextItemSelector with: itemMorph.
			^ itemMorph drawOn: canvas].
	canvas
		drawString: item
		in: drawBounds
		font: font
		color: textColor! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mu 2/25/2004 17:55'!
drawItem: item at: rowIndex on: aCanvas 
	| itemSelected |
	itemSelected := self rowIsSelected: rowIndex.
	itemSelected
		ifTrue: [self drawSelectionBackgroundFor: rowIndex on: aCanvas].
	self
		display: item
		atRow: rowIndex
		on: aCanvas! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mu 2/22/2004 02:45'!
drawOn: aCanvas 
	self listItems size = 0
		ifTrue: [^ self].
	(self topVisibleRowForCanvas: aCanvas)
		to: (self bottomVisibleRowForCanvas: aCanvas)
		do: [:rowIndex | 
			| item | 
			item := self itemAt: rowIndex.
			self drawItem: item at: rowIndex on: aCanvas].
	listSource potentialDropRow > 0
		ifTrue: [self highlightPotentialDropRow: listSource potentialDropRow on: aCanvas]! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mu 2/22/2004 19:55'!
drawSelectionBackgroundFor: row on: aCanvas
	| selectionDrawBounds |
	"shade the background darker, if this row is selected"

	selectionDrawBounds := self drawingBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas fillRectangle: selectionDrawBounds color:  (self selectionBackgroundColor)! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mu 2/20/2004 19:31'!
highlightPotentialDropRow: row  on: aCanvas
	| drawBounds  |
	drawBounds := self drawingBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	aCanvas frameRectangle: drawBounds color: Color blue! !

!LazyListMorph methodsFor: 'list colors' stamp: 'mu 2/25/2004 20:07'!
colorForRow: rowIndex 
	listSource rowColorSelector
		ifNotNil: [| customColor | 
			customColor := listSource model
						perform: listSource rowColorSelector
						with: (self itemAt: rowIndex).
			customColor isColor
				ifTrue: [^ customColor]].
	^ self color! !

!LazyListMorph methodsFor: 'list colors' stamp: 'mu 2/25/2004 17:55'!
foregroundColorForRow: rowIndex
	^(self rowIsSelected: rowIndex)
		ifTrue: [ self selectionColorForRow: rowIndex ]
		ifFalse: [ self colorForRow: rowIndex ].! !

!LazyListMorph methodsFor: 'list colors' stamp: 'mu 2/25/2004 20:04'!
selectionBackgroundColorForRow: rowIndex 
	listSource selectionBackgroundColorSelector
		ifNotNil: [| customColor | 
			customColor := listSource model
						perform: listSource selectionBackgroundColorSelector
						with: (self itemAt: rowIndex).
			customColor isColor 
				ifTrue: [^ customColor]].
	^ self selectionColor! !

!LazyListMorph methodsFor: 'list colors' stamp: 'mu 2/25/2004 20:02'!
selectionColorForRow: rowIndex 
	listSource selectionColorSelector
		ifNotNil: [| customColor | 
			customColor := listSource model
						perform: listSource selectionColorSelector
						with: (self itemAt: rowIndex).
			customColor isColor
				ifTrue: [^ customColor]].
	^ self selectionColor! !

!LazyListMorph methodsFor: 'list access' stamp: 'mu 2/24/2004 23:39'!
getListHeight
	| height size |
	height := 0.
	size := self getListSize.
	1to: size do: [:idx | 
			| item eachHeight | 
			item := self itemAt: idx.
			eachHeight := self heightOf: item.
			height := height + eachHeight].
	^ height! !

!LazyListMorph methodsFor: 'list access' stamp: 'mu 2/25/2004 01:03'!
itemAt: index
	| items |
	items _ self listItems.
	(index between: 1 and: items size)
		ifFalse: [ "there should have been an update, but there wasn't!!"  ^self getListItem: index].
	(items at: index) ifNil: [ 
		items at: index put: (self getListItem: index). ].
	^items at: index! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/23/2004 20:31'!
font
	^font! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/23/2004 20:31'!
font: aFont
	font := aFont! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/20/2004 20:02'!
listItems

	^listItems! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 19:38'!
listItems: items
	listItems _ items! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:14'!
rowColor
	^self color! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:14'!
rowColor: aColor

	self color: aColor! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:48'!
selectionBackgroundColor
	selectionBackgroundColor ifNil: [selectionBackgroundColor := self class selectionBackgroundColor ].
	^selectionBackgroundColor! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 19:50'!
selectionBackgroundColor: aColor

	selectionBackgroundColor := aColor! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:48'!
selectionColor
	selectionColor ifNil: [selectionColor := self class selectionColor ].
	^selectionColor! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 19:45'!
selectionColor: aColor

	selectionColor := aColor! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/25/2004 18:03'!
textItemMorphClass
	textItemMorphClass ifNil: [textItemMorphClass :=BorderedStringMorph].
	^textItemMorphClass! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mu 2/25/2004 18:02'!
textItemMorphClass: aClass

	textItemMorphClass := aClass! !

!LazyListMorph methodsFor: 'private' stamp: 'mu 2/25/2004 00:00'!
adjustHeight
	"private.  Adjust our height to match the length of the underlying list"
	self height: self getListHeight! !

!LazyListMorph methodsFor: 'private' stamp: 'mu 2/25/2004 01:17'!
heightOf: item
	item ifNil: [^0].
	^item isMorph ifTrue: [item height] ifFalse: [font height].! !

!LazyListMorph methodsFor: 'private' stamp: 'mu 2/24/2004 23:48'!
upperListHeightTo: rowIndex
	| height |
	height := 0.
	1to: rowIndex - 1 do: [:idx | 
			| item eachHeight | 
			item := self itemAt: idx.
			eachHeight := self heightOf: item.
			height := height + eachHeight].
	^ height! !


!LazyListMorph class methodsFor: 'class initialization' stamp: 'mu 2/25/2004 01:41'!
initialize
	"LazyListMorph initialize"
	RowColor := self defaultRowColor.
	SelectionColor := self defaultSelectionColor.
	SelectionBackgroundColor := self defaultSelectionBackgroundColor	! !

!LazyListMorph class methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:46'!
rowColor
	RowColor ifNil: [RowColor := self defaultRowColor].
	^RowColor! !

!LazyListMorph class methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:46'!
rowColor: aColor
	RowColor := aColor! !

!LazyListMorph class methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:47'!
selectionBackgroundColor
	SelectionBackgroundColor ifNil: [SelectionBackgroundColor := self defaultSelectionBackgroundColor].
	^SelectionBackgroundColor! !

!LazyListMorph class methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:46'!
selectionBackgroundColor: aColor
	SelectionBackgroundColor := aColor! !

!LazyListMorph class methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:47'!
selectionColor
	SelectionColor ifNil: [SelectionColor := self defaultSelectionColor].
	^SelectionColor! !

!LazyListMorph class methodsFor: 'accessing' stamp: 'mu 2/25/2004 17:45'!
selectionColor: aColor
	SelectionColor := aColor! !

!LazyListMorph class methodsFor: 'defaults' stamp: 'mu 2/25/2004 01:38'!
defaultRowColor
	"TO-DO: Use Preferences"
	^Color black! !

!LazyListMorph class methodsFor: 'defaults' stamp: 'mu 2/25/2004 01:39'!
defaultSelectionBackgroundColor
	"TO-DO: Use Preferences"
	^Color lightGray alpha: 0.3! !

!LazyListMorph class methodsFor: 'defaults' stamp: 'mu 2/25/2004 01:39'!
defaultSelectionColor
	"TO-DO: Use Preferences"
	^Color red! !


!MessageSet methodsFor: 'private' stamp: 'mu 2/25/2004 18:09'!
buildMorphicMessageList
	"Build my message-list object in morphic"

	| aListMorph |
	aListMorph _ PluggableListMorph new.
	aListMorph
		setProperty: #itemConversionMethod toValue: #asStringOrText;
		setProperty: #balloonTextSelectorForSubMorphs toValue: #balloonTextForClassAndMethodString.
	aListMorph
		on: self list: #messageList
		selected: #messageListIndex changeSelected: #messageListIndex:
		menu: #messageListMenu:shifted:
		keystroke: #messageListKey:from:.
	aListMorph enableDragNDrop: Preferences browseWithDragNDrop.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	^ aListMorph

! !


!MulticolumnLazyListMorph methodsFor: 'drawing' stamp: 'mu 2/22/2004 21:18'!
display: items  atRow: row on: canvas
        "display the specified item, which is on the specified row; for Multicolumn lists, item w
ill be a list of strings"
        | drawBounds |
        drawBounds := self drawingBoundsForRow: row.
        drawBounds := drawBounds intersect: self bounds.

        items with: (1 to: items size) do: [ :item :index |
                "move the bounds to the right at each step"
                index > 1 ifTrue: [
                        drawBounds := drawBounds left: (drawBounds left + 6 + (columnWidths at: index - 1)). ].
                canvas drawString: item in: drawBounds font: font color: (self foregroundColorForRow: row) ]! !

!MulticolumnLazyListMorph methodsFor: 'drawing' stamp: 'mu 2/20/2004 19:39'!
setColumnWidthsFor: aCanvas
        | row topRow bottomRow |
        "set columnWidths for drawing on the specified canvas"
		columnWidths ifNil: [
		columnWidths := (self itemAt: 1) collect: [ :ignored | 0 ]. ].
	topRow := (self topVisibleRowForCanvas: aCanvas) max: 1.
	bottomRow :=  (self bottomVisibleRowForCanvas: aCanvas) max: 1.
	topRow > bottomRow ifTrue: [ ^ self ].
	topRow to: bottomRow do: [ :rowIndex |
                row := self itemAt: rowIndex.
                columnWidths := columnWidths with: row collect: [ :currentWidth :item |
				| widthOfItem |
				widthOfItem := (font widthOfString: item).
				widthOfItem > currentWidth
					ifTrue: [ self changed.  widthOfItem ]
					ifFalse: [ currentWidth ] ] ]! !


!PLMSimpleTestModel methodsFor: 'accessing' stamp: 'mu 2/25/2004 18:14'!
list
	^ list! !

!PLMSimpleTestModel methodsFor: 'accessing' stamp: 'mu 2/22/2004 20:58'!
list: objects
	list := objects! !

!PLMSimpleTestModel methodsFor: 'accessing' stamp: 'mu 2/25/2004 00:53'!
selectedListIndex: index
	selectedListIndex _ index.
	self changed: #selectedListIndex.	
	^selectedListIndex! !

!PLMSimpleTestModel methodsFor: 'highlighting' stamp: 'mu 2/25/2004 01:34'!
highlightMorphItem: itemMorph 
	| color |
	color := (itemMorph valueOfProperty: #selectedInRow)
				ifTrue: [Color red]
				ifFalse: [Color gray].
	itemMorph color: color! !

!PLMSimpleTestModel methodsFor: 'highlighting' stamp: 'mu 2/27/2004 17:04'!
highlightTextItem: itemMorph
	itemMorph emphasis: TextEmphasis bold emphasisCode.
	itemMorph contents: (itemMorph contents, '[bold]').
	! !


!PLMSimpleTestModel class methodsFor: 'examples' stamp: 'mu 2/25/2004 01:44'!
example1
	"normal list"
	(self plmWith: self stringList) openInWorld! !

!PLMSimpleTestModel class methodsFor: 'examples' stamp: 'mu 2/25/2004 01:46'!
example2
	"changing selection color"
	| plm |
	plm := (self plmWith: self stringList) .
	plm renderer selectionColor: Color blue.
	plm openInWorld! !

!PLMSimpleTestModel class methodsFor: 'examples' stamp: 'mu 2/25/2004 01:46'!
example3
	"changing many default colors"
	| plm |
	plm := (self plmWith: self stringList) .
	plm renderer selectionColor: Color blue.
	plm renderer selectionBackgroundColor: Color red muchLighter.
	plm renderer rowColor: Color brown.
	plm openInWorld! !

!PLMSimpleTestModel class methodsFor: 'examples' stamp: 'mu 2/25/2004 01:45'!
example4
	"using highlightTextItemSelector: to add custom highlighting behaviors"
	| plm |
	plm := (self plmWith: self stringList) .
	plm highlightTextItemSelector: #highlightTextItem:.
	plm openInWorld! !

!PLMSimpleTestModel class methodsFor: 'examples' stamp: 'mu 2/25/2004 01:46'!
example5
	"morph list"
	| plm |
	plm := (self plmWith: self morphList) .
	plm renderer selectionBackgroundColor: Color green.
	plm openInWorld! !

!PLMSimpleTestModel class methodsFor: 'examples' stamp: 'mu 2/25/2004 01:46'!
example6
	"using highlightMorphItemSelector: to add custom highlighting behaviors"
	| plm |
	plm := (self plmWith: self morphList) .
	plm highlightMorphItemSelector: #highlightMorphItem:.
	plm openInWorld! !

!PLMSimpleTestModel class methodsFor: 'examples' stamp: 'mu 2/27/2004 17:06'!
example7
	"mixed list with multi highlighters"
	| plm |
	plm := (self plmWith: self stringAndMorphList) .
	plm highlightMorphItemSelector: #highlightMorphItem:.
	plm highlightTextItemSelector: #highlightTextItem:.
	plm openInWorld! !

!PLMSimpleTestModel class methodsFor: 'instance creation' stamp: 'mu 2/22/2004 21:00'!
plmWith: list
	| model |
	model  := self new.
	model list: list.
	^PluggableListMorph
				on: model
				list: #list
				selected: #selectedListIndex
				changeSelected: #selectedListIndex:.
! !

!PLMSimpleTestModel class methodsFor: 'defaults' stamp: 'mu 2/25/2004 23:50'!
morphList
	^{EllipseMorph new. EllipseMorph new. EllipseMorph new.  }! !

!PLMSimpleTestModel class methodsFor: 'defaults' stamp: 'mu 2/24/2004 22:10'!
stringAndIntegerList
	^#('hello' 'squeak' 2004)! !

!PLMSimpleTestModel class methodsFor: 'defaults' stamp: 'mu 2/25/2004 01:36'!
stringAndMorphList
	^{BlobMorph new. 'squeak'. EllipseMorph new}! !

!PLMSimpleTestModel class methodsFor: 'defaults' stamp: 'mu 2/22/2004 20:58'!
stringList
	^#('hello' 'squeak' 'world')! !


!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/25/2004 01:06'!
highlightMorphItemSelector
	^self valueOfProperty: #highlightMorphItemSelector! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/25/2004 01:07'!
highlightMorphItemSelector: aSelector
	self setProperty: #highlightMorphItemSelector toValue: aSelector.
	! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/24/2004 21:19'!
highlightTextItemSelector
	^self valueOfProperty: #highlightTextItemSelector! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/24/2004 21:19'!
highlightTextItemSelector: aSelector
	self setProperty: #highlightTextItemSelector toValue: aSelector.
	! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:11'!
rowColorSelector
	^self valueOfProperty: #rowColorSelector! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:12'!
rowColorSelector: aSelector
	self setProperty: #rowColorSelector toValue: aSelector.
	! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:16'!
selectionBackgroundColorSelector
	^self valueOfProperty: #selectionBackgroundColorSelector! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:16'!
selectionBackgroundColorSelector: aSelector
	self setProperty: #selectionBackgroundColorSelector toValue: aSelector.
	! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:10'!
selectionColorSelector
	^self valueOfProperty: #selectionColorSelector! !

!PluggableListMorph methodsFor: 'accessing' stamp: 'mu 2/22/2004 21:10'!
selectionColorSelector: aSelector
	self setProperty: #selectionColorSelector toValue: aSelector.
	! !

!PluggableListMorph methodsFor: 'model access' stamp: 'mu 2/24/2004 22:14'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"
	getListSelector == nil ifTrue: [^ #()].
	list _ model perform: getListSelector.
	list == nil ifTrue: [^ #()].
	^ list! !

!PluggableListMorph methodsFor: 'model access' stamp: 'mu 2/25/2004 01:14'!
getListItem: index
	"get the index-th item in the displayed list"
	getListElementSelector ifNotNil: [ ^(model perform: getListElementSelector with: index) asStringOrText ].
	list ifNotNil: [ ^list at: index ifAbsent:[] ].
	^self getList at: index ifAbsent:[]! !

!PluggableListMorph methodsFor: 'selection' stamp: 'mu 2/25/2004 18:28'!
rowIsSelected: index
	^self selectionIndex = index! !

!PluggableListMorph methodsFor: 'selection' stamp: 'mu 2/20/2004 19:31'!
scrollSelectionIntoView
	"make sure that the current selection is visible"
	| row |
	row := self getCurrentSelectionIndex.
	row = 0 ifTrue: [ ^ self ].
	self scrollToShow: (self listMorph drawingBoundsForRow: row)! !

!PluggableListMorph methodsFor: 'selection' stamp: 'mu 2/20/2004 19:21'!
selectionIndex
	"return the index we have currently selected, or 0 if none"
	^self listMorph selectedRowIndex ifNil: [ 0 ]! !

!PluggableListMorph methodsFor: 'selection' stamp: 'mu 2/20/2004 19:21'!
selectionIndex: index
	"Called internally to select the index-th item."
	| row |
	self unhighlightSelection.
	row := index ifNil: [ 0 ].
	row := row min: self getListSize.  "make sure we don't select past the end"
	self listMorph selectedRowIndex: row.
	self highlightSelection.
	self scrollSelectionIntoView.! !

!PluggableListMorph methodsFor: 'submorphs-accessing' stamp: 'mu 2/25/2004 23:55'!
scrollBar
	^scrollBar! !

!PluggableListMorph methodsFor: 'lazy list access' stamp: 'mu 2/25/2004 01:02'!
renderer
	^self listMorph! !


!PluggableListMorphOfMany methodsFor: 'selection' stamp: 'mu 2/25/2004 18:28'!
rowIsSelected: index
	^model listSelectionAt: index! !

PluggableListMorphOfMany removeSelector: #itemSelectedAmongMultiple:!
PluggableListMorphOfMany removeSelector: #list:!

!PluggableListMorphOfMany reorganize!
('drawing' listSelectionAt: listSelectionAt:put:)
('event handling' mouseDown: mouseMove: mouseUp:)
('initialization' on:list:primarySelection:changePrimarySelection:listSelection:changeListSelection:menu:keystroke:)
('updating' update:)
('selection' rowIsSelected:)
!

PluggableListMorph removeSelector: #highlightSelector!
PluggableListMorph removeSelector: #highlightSelector:!
PluggableListMorph removeSelector: #itemSelectedAmongMultiple:!
PluggableListMorph removeSelector: #list:!
PluggableListMorph removeSelector: #selectedMorph!
PluggableListMorph removeSelector: #selectedMorph:!

!PluggableListMorph reorganize!
('accessing' highlightMorphItemSelector highlightMorphItemSelector: highlightTextItemSelector highlightTextItemSelector: itemFromPoint: rowAtLocation: rowColorSelector rowColorSelector: selectionBackgroundColorSelector selectionBackgroundColorSelector: selectionColorSelector selectionColorSelector:)
('debug and other' installModelIn:)
('drag and drop' acceptDroppingMorph:event: potentialDropItem potentialDropRow resetPotentialDropRow startDrag:)
('drawing' highlightSelection superDrawOn: unhighlightSelection)
('dropping/grabbing' wantsDroppedMorph:event:)
('event handling' handlesKeyboard: handlesMouseOverDragging: keyStroke: keyboardFocusChange: mouseEnter:)
('events' doubleClick: handleBasicKeys: handlesBasicKeys mouseDown: mouseEnterDragging: mouseLeave: mouseLeaveDragging: mouseMove: mouseUp:)
('events-processing' handleMouseMove:)
('geometry' extent: scrollDeltaHeight)
('initialization' autoDeselect: doubleClickSelector: font font: getListElementSelector: getListSelector: getListSizeSelector: initForKeystrokes keystrokeActionSelector: listItemHeight on:list:selected:changeSelected:menu:keystroke: textColor textColor: textHighlightColor textHighlightColor:)
('layout')
('menu' getMenu:)
('menus' addCustomMenuItems:hand: copyListToClipboard copySelectionToClipboard setListFont)
('model access' basicKeyPressed: changeModelSelection: commandKeyTypedIntoMenu: getCurrentSelectionIndex getList getListItem: getListSize modifierKeyPressed: specialKeyPressed:)
('obsolete' doubleClick:onItem: mouseDown:onItem: mouseEnterDragging:onItem: mouseLeaveDragging:onItem: mouseUp:onItem: removeObsoleteEventHandlers startDrag:onItem:)
('selection' getListSelector maximumSelection minimumSelection numSelectionsInView rowIsSelected: scrollSelectionIntoView selection selection: selectionIndex selectionIndex: setGetListSelector: setSelectedMorph:)
('submorphs-accessing' allSubmorphNamesDo: scrollBar)
('updating' update: updateList verifyContents)
('lazy list access' listMorph listMorphClass renderer)
!

LazyListMorph initialize!
LazyListMorph removeSelector: #drawBackgroundForMulti:on:!
LazyListMorph removeSelector: #drawBackgroundForPotentialDrop:on:!
LazyListMorph removeSelector: #drawBoundsForRow:!
LazyListMorph removeSelector: #drawSelectionOn:!
LazyListMorph removeSelector: #item:!
LazyListMorph removeSelector: #selectRow:!
LazyListMorph removeSelector: #selectedRow!
LazyListMorph removeSelector: #selectedRow:!
LazyListMorph removeSelector: #unselectRow:!
Morph subclass: #LazyListMorph
	instanceVariableNames: 'listItems font selectedRowIndex listSource selectionColor selectionBackgroundColor textItemMorphClass'
	classVariableNames: 'RowColor SelectionBackgroundColor SelectionColor'
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!LazyListMorph reorganize!
('initialization' initialize listSource:)
('list management' drawingBoundsForRow: listChanged rowAtLocation: rowIsSelected: selectedRowIndex selectedRowIndex:)
('drawing' bottomVisibleRowForCanvas: display:atRow:on: displayMorph:atRow:on: displayText:atRow:on: drawItem:at:on: drawOn: drawSelectionBackgroundFor:on: highlightPotentialDropRow:on: topVisibleRowForCanvas:)
('list colors' colorForRow: foregroundColorForRow: selectionBackgroundColorForRow: selectionColorForRow:)
('list access' getListHeight getListItem: getListSize itemAt:)
('accessing' font font: listItems listItems: rowColor rowColor: selectionBackgroundColor selectionBackgroundColor: selectionColor selectionColor: textItemMorphClass textItemMorphClass:)
('private' adjustHeight heightOf: upperListHeightTo:)
!

Browser removeSelector: #highlightClassList:with:!
Browser removeSelector: #highlightMessageCategoryList:with:!
Browser removeSelector: #highlightMessageList:with:!
Browser removeSelector: #highlightSystemCategoryList:with:!
